package PCC;

import javax.swing.SwingUtilities;

import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.Color;

import javax.swing.JLabel;
import java.awt.Rectangle;

import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import javax.swing.JButton;

import PCC.CadastarLog;

public class TelaLogindoSistema extends JFrame {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JLabel lbLogin = null;

	private JLabel lbSenha = null;

	private JTextField login = null;

	private JPasswordField senha = null;

	private JButton jButton = null;

	/**
	 * This method initializes login	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getLogin() {
		if (login == null) {
			login = new JTextField();
			login.setBounds(new Rectangle(80, 68, 160, 22));
		}
		return login;
	}

	/**
	 * This method initializes senha	
	 * 	
	 * @return javax.swing.JPasswordField	
	 */
	private JPasswordField getSenha() {
		if (senha == null) {
			senha = new JPasswordField();
			senha.setBounds(new Rectangle(80, 104, 160, 22));
		}
		return senha;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setBounds(new Rectangle(15, 143, 224, 26));
			jButton.setText("Acessar");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// recolhendo os dados do formulrio
					String fLogin = login.getText();
					String fSenha = new String(senha.getPassword());
					// cria o objeto de cadastro e verifica a senha
					CadastarLog cl = new CadastarLog();
					cl.setLogin(fLogin);
					cl.setSenha(fSenha);
					String sNivel = cl.procura();
					// verifica o nvel de senha
					if (sNivel.equals("A")) {// administrador
					   MenuEntrada a = new MenuEntrada();
					   a.setVisible(true);
					}
					if (sNivel.equals("C")) {// comum
						MenuEntradaComum a = new MenuEntradaComum();
						a.setVisible(true);
					}
					if (sNivel.equals("d")) {// desconhecido
						// alerta de erro: desconhecido
						JOptionPane.showMessageDialog(null,
								"Login ou senha incorretos!", "Erro",
								JOptionPane.WARNING_MESSAGE);
					}
					if (sNivel.equals("e")) {// erro interno
						JOptionPane.showMessageDialog(null,
								"Erro na execuo!", "Erro",
								JOptionPane.ERROR_MESSAGE);
					}
				}
			});
		}
		return jButton;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				TelaLogindoSistema thisClass = new TelaLogindoSistema();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	/**
	 * This is the default constructor
	 */
	public TelaLogindoSistema() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(434, 306);
		this.setContentPane(getJContentPane());
		this.setTitle("Tela Inicial");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		
	
		if (jContentPane == null) {
			lbSenha = new JLabel();
			lbSenha.setBounds(new Rectangle(15, 105, 56, 22));
			lbSenha.setText("Senha");
			lbLogin = new JLabel();
			lbLogin.setBounds(new Rectangle(15, 68, 56, 22));
			lbLogin.setText("Login");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBackground(Color.white);
			jContentPane.add(lbLogin, null);
			jContentPane.add(lbSenha, null);
			jContentPane.add(getLogin(), null);
			jContentPane.add(getSenha(), null);
			jContentPane.add(getJButton(), null);
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="115,8"

