package PCC;

import java.awt.EventQueue;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Iterator;
import java.util.List;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import java.awt.Rectangle;
import java.awt.Dimension;
import java.awt.Point;



public class TelaVenda extends JFrame {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String produto;  //  @jve:decl-index=0:
	private JPanel jContentPane = null;
	private JTextField textQtdade = null;
	private JComboBox comboProdutos = null;
	private JComboBox combocliente = null;
	private JTextField textPreco = null;
	private JTable tabelaItensVendas = null;
	private JButton btAdiciona = null;
	private JButton btFinalizaVenda = null;
	private VendaTableModel model;
	private List ItensVenda = null;
	private ItemVenda itemVenda = null;
	private JTextField textTotal = null;
	private JLabel LabelTotal = null;
	private JButton btRemover = null;
	public static Connection con = null;
	private Statement stmt=null;
	private List<ItemVenda> produtos;
	private JLabel labelCliente = null;
	private JLabel labelProd = null;
	private JLabel labelPreco = null;
	private JLabel labelQtdade = null;
	private JButton btLimpar = null;
	private JButton jButton = null;
	private JLabel jLabel = null;
	private JTextField tdata = null;
	private JLabel jLabel1 = null;
	private JComboBox comcodforma = null;

	/**
	 * This is the default constructor
	 * @throws Exception 
	 */
	public TelaVenda() throws Exception {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 * @throws Exception 
	 */
	private void initialize() throws Exception {
		this.setSize(648, 466);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");

	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel1 = new JLabel();
			jLabel1.setBounds(new java.awt.Rectangle(316,121,105,16));
			jLabel1.setText("Cdigo da Forma:");
			jLabel = new JLabel();
			jLabel.setBounds(new java.awt.Rectangle(16,119,98,16));
			jLabel.setText("Data da Venda :");
			labelQtdade = new JLabel();
			labelQtdade.setBounds(new java.awt.Rectangle(418,63,76,21));
			labelQtdade.setText("Quantidade");
			labelPreco = new JLabel();
			labelPreco.setBounds(new java.awt.Rectangle(246,62,53,19));
			labelPreco.setText("Preco");
			labelProd = new JLabel();
			labelProd.setBounds(new java.awt.Rectangle(19,59,60,22));
			labelProd.setText("Produtos");
			labelCliente = new JLabel();
			labelCliente.setBounds(new java.awt.Rectangle(57,6,62,40));
			labelCliente.setText("Cliente");
			LabelTotal = new JLabel();
			LabelTotal.setBounds(new Rectangle(501, 351, 99, 26));
			LabelTotal.setText("Total da Venda");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getTextQtdade(), null);
			jContentPane.add(getComboProdutos(), null);
			jContentPane.add(getCombocliente(), null);
			jContentPane.add(getTextPreco(), null);
			jContentPane.add(getTabelaItensVendas(), null);
			jContentPane.add(getBtAdiciona(), null);
			jContentPane.add(getBtFinalizaVenda(), null);
			jContentPane.add(getTextTotal(), null);
			jContentPane.add(LabelTotal, null);
			jContentPane.add(getBtRemover(), null);
			jContentPane.add(labelCliente, null);
			jContentPane.add(labelProd, null);
			jContentPane.add(labelPreco, null);
			jContentPane.add(labelQtdade, null);
			jContentPane.add(getBtLimpar(), null);
			jContentPane.add(getJButton(), null);
			jContentPane.add(jLabel, null);
			jContentPane.add(getTdata(), null);
			jContentPane.add(jLabel1, null);
			jContentPane.add(getComcodforma(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes textQtdade	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTextQtdade() {
		if (textQtdade == null) {
			textQtdade = new JTextField();
			textQtdade.setBounds(new java.awt.Rectangle(503,61,53,27));
		}
		return textQtdade;
	}

	/**
	 * This method initializes comboProdutos	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getComboProdutos() {
		if (comboProdutos == null) {
			
			comboProdutos = new JComboBox();
			comboProdutos.setBounds(new java.awt.Rectangle(95,61,135,29));		

			Banco banco = new Banco();
			try{
				Connection ExConn = banco.abrirBDConn();
				Statement stmt = ExConn.createStatement();
				ResultSet rs = stmt.executeQuery("SELECT * FROM tabprod");
				while(rs.next()){
					comboProdutos.addItem(rs.getString("nome"));
				}
				stmt.close();
				banco.fecharBDConn();
			}catch(Exception e){
				System.out.println(e.getMessage());
			}
			
			comboProdutos.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					String prod = (String)comboProdutos.getSelectedItem();
					setProduto(prod);
					float valor = 0;
					Banco banco = new Banco();
					try{
						Connection ExConn = banco.abrirBDConn();
						Statement stmt = ExConn.createStatement();
						System.out.println("Produto: "+prod);
						ResultSet rs = stmt.executeQuery("SELECT * FROM tabprod WHERE nome = '"+getProduto()+"'");
						while(rs.next()){
							valor = rs.getFloat("valor");
						}
						stmt.close();
						banco.fecharBDConn();
					}catch(Exception ex){
						System.out.println(ex.getMessage());
					}
					System.out.println("Valor: "+valor);
					String var = String.valueOf(valor);
					System.out.println(var);

					textPreco.setText(var);
				}
			});
			
			
			
    			
		}
		
				
		return comboProdutos;
	}

	/**
	 * This method initializes combocliente	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getCombocliente() {
		if (combocliente == null) {
			combocliente = new JComboBox();
			combocliente.setBounds(new java.awt.Rectangle(130,13,390,29));
			Banco banco = new Banco();
			try{
				Connection ExConn = banco.abrirBDConn();
				Statement stmt = ExConn.createStatement();
				ResultSet rs = stmt.executeQuery("SELECT * FROM tabcli");
				while(rs.next()){
					combocliente.addItem(rs.getString("nome"));
				}
				stmt.close();
				banco.fecharBDConn();
			}catch(Exception e){
				System.out.println(e.getMessage());
			}

		}
		
		
		return combocliente;
	}

	/**
	 * This method initializes textPreco	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTextPreco() {
		if (textPreco == null) {
			textPreco = new JTextField();
			textPreco.setBounds(new java.awt.Rectangle(340,62,53,27));
		}
		return textPreco;
	}

	/**
	 * This method initializes tabelaItensVendas	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getTabelaItensVendas() {
		if (tabelaItensVendas == null) {
			tabelaItensVendas = new JTable();
			tabelaItensVendas.setBounds(new Rectangle(64, 178, 444, 174));
			tabelaItensVendas.setModel(new VendaTableModel());
		}
		return tabelaItensVendas;
	}

	private VendaTableModel getModel() {
		if (model == null) {
			model = (VendaTableModel) getTabelaItensVendas().getModel();
		}
		return model;
	}
	
	/**
	 * This method initializes btAdiciona	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtAdiciona() {
		if (btAdiciona == null) {
			btAdiciona = new JButton();
			btAdiciona.setBounds(new Rectangle(527, 205, 89, 44));
			btAdiciona.setText("+");
			btAdiciona.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					if (!(comboProdutos.getSelectedItem().toString().isEmpty() || (textQtdade.getText().isEmpty())
							|| (textPreco.getText().isEmpty()))){
						addSocio();						
						}else{
							JOptionPane.showMessageDialog(null,"Informe o produto e a quantidade comprada!");
						}
				}
			});
		}
		return btAdiciona;
	}

	/**
	 * This method initializes btFinalizaVenda	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtFinalizaVenda() {
		final ResultSet rs = null;
		if (btFinalizaVenda == null) {
			btFinalizaVenda = new JButton();
			btFinalizaVenda.setBounds(new Rectangle(196, 375, 106, 31));
			btFinalizaVenda.setText("Calcular");
			btFinalizaVenda.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
						
							ItensVenda = model.getItensVenda();
							Iterator itr = ItensVenda.iterator(); 
							ItemVenda itemVenda= new ItemVenda();
							double totalVenda = 0;
							while(itr.hasNext()) {

							    itemVenda = (ItemVenda) itr.next(); 
							    System.out.println("Produto:"+itemVenda.getProduto());
							    System.out.println("Preo:"+itemVenda.getPreco());
							    System.out.println("Quantidade:"+itemVenda.getQtdade());
							    System.out.println("Total do Item:"+itemVenda.getTotalItem());
							    System.out.println();
							    
							    totalVenda = totalVenda + itemVenda.getTotalItem();

							} 
							
							textTotal.setText(""+totalVenda);					
						}

			});
		}
		return btFinalizaVenda;
	}
	
	private void addSocio() {
		if(getSocio() != null){
			getModel().addItemVenda(getSocio());
		}
	}
	
	private ItemVenda getSocio() {
		ItemVenda itemVenda = new ItemVenda();
		
		itemVenda.setProduto(comboProdutos.getSelectedItem().toString());
		itemVenda.setPreco(Double.parseDouble(textPreco.getText()));
		itemVenda.setQtdade(Integer.parseInt(textQtdade.getText()));
		itemVenda.setTotalItem(itemVenda.getPreco()*itemVenda.getQtdade());
		return itemVenda;
	}

	/**
	 * This method initializes textTotal	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTextTotal() {
		if (textTotal == null) {
			textTotal = new JTextField();
			textTotal.setBounds(new Rectangle(498, 376, 95, 28));
		}
		return textTotal;
	}

	/**
	 * This method initializes btRemover	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtRemover() {
		if (btRemover == null) {
			btRemover = new JButton();
			btRemover.setText("-");
			btRemover.setSize(new Dimension(89, 44));
			btRemover.setLocation(new Point(527, 267));
			btRemover.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if(tabelaItensVendas.getSelectedRow() == -1){
						JOptionPane.showMessageDialog(null,"Selecione um item da venda");
					}else{
						model.removeSocio(tabelaItensVendas.getSelectedRow());
					}
				}
			});
		}
		return btRemover;
	}
	
	/**
	 * This method initializes btLimpar	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBtLimpar() {
		if (btLimpar == null) {
			btLimpar = new JButton();
			btLimpar.setText("Limpar");
			btLimpar.setBounds(new Rectangle(45, 375, 106, 31));
			btLimpar.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					model.limpar();
				}
			});
		}
		return btLimpar;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setBounds(new Rectangle(347, 375, 106, 31));
			jButton.setText("Concluir");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					ItensVenda = model.getItensVenda();
					Iterator itr = ItensVenda.iterator(); 
					ItemVenda itemVenda= new ItemVenda();
					double totalVenda = 0;
					String nomecli = (String)combocliente.getSelectedItem();
					String datavenda = tdata.getText();
					int codforma = comcodforma.getSelectedIndex();
					codforma += 1;
					int numChave = 0;
					ItemVenda venda = new ItemVenda();
					numChave = venda.inserirvendabanco(nomecli,datavenda,codforma );
					while(itr.hasNext()) {
					    itemVenda = (ItemVenda) itr.next();
					    venda.inserirprodutosvenda(numChave, itemVenda.getProduto(), itemVenda.getQtdade(), itemVenda.getTotalItem());
					    System.out.println("Produto: "+itemVenda.getProduto());
					    System.out.println("Preo: "+itemVenda.getPreco());
					    System.out.println("Quantidade: "+itemVenda.getQtdade());
					    System.out.println("Data da venda: "+itemVenda.getDatavenda());
					    System.out.println();
					    System.out.println("Total do Item: "+itemVenda.getTotalItem());
					    System.out.println();
					 
					    totalVenda = totalVenda + itemVenda.getTotalItem();

					} 
					
					textTotal.setText(""+totalVenda);	
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes tdata	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTdata() {
		if (tdata == null) {
			tdata = new JTextField();
			tdata.setBounds(new java.awt.Rectangle(127,119,146,20));
		}
		return tdata;
	}

	/**
	 * This method initializes comcodforma	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getComcodforma() {
		if (comcodforma == null) {
			comcodforma = new JComboBox();
			Banco banco = new Banco();
			try{
				Connection ExConn = banco.abrirBDConn();
				Statement stmt = ExConn.createStatement();
				ResultSet rs = stmt.executeQuery("SELECT formapag FROM tabformapagjava ORDER BY formapag");
				while (rs.next()){
					comcodforma.addItem(rs.getString("formapag"));
				}
				comcodforma.setBounds(new java.awt.Rectangle(427,119,182,20));
				stmt.close();
			}catch(Exception ex){
				ex.printStackTrace();
			}}

			comcodforma.setBounds(new java.awt.Rectangle(434,117,87,25));
		
		return comcodforma;
	}

	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try{
				TelaVenda thisClass = new TelaVenda();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
				}catch(Exception ex){
					
					}
				}
				
		});
	}

	public String getProduto() {
		return produto;
	}

	public void setProduto(String produto) {
		this.produto = produto;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
