<?php
abstract class Conta
{
    private   $titular;
    private   $senha;
    protected $saldo = 0;
    public    $agencia;
    public    $conta;
    
    abstract function saque($valor);
    function deposito($valor)
    {
        $this->saldo += $valor;
    }
    abstract function transferencia($conta, $valor);    
}

class ContaPoupanca extends Conta
{
    public $dataBase;
    function saque($valor)
    {
        if($valor <= $this->saldo)
        {
            $this->saldo -= $valor;
            return true;
        }
        else
        {
            return false;
        }
    }
    
    function transferencia($conta, $valor)
    {
        if($this->saque($valor))
        {
            $conta->deposito($valor);
            return true;
        }
        else
        {
            return false;
        }
    }
}
class ContaCorrente extends Conta
{
    public $limite;
    function saque($valor)
    {
        if($valor <= ($this->saldo + $this->limite) )
        {
            $this->saldo -= $valor;
            if($this->saldo < 0)
            {
                $this->limite += $saldo;
                $this->saldo   = 0;
            }
            return true;
        }
        else
        {
            return false;
        }
    }
    
    function transferencia($conta, $valor)
    {
        $taxa = 0;
        if($valor > 5000)
        {
            $taxa = 15;
        }
        if($this->saque($valor + $taxa))
        {
            $conta->deposito($valor);
            return true;
        }
        else
        {
            return false;
        }
    }
}
$p2 = new ContaCorrente();
$p1 = new ContaPoupanca();
$p1->deposito(10000);
$p1->transferencia($p2, 100);
print_r($p1);
print_r($p2);
?>