<?php

/*
1.	Vamos pensar em meios de transporte. Pensemos primeiro em alguns meios de transporte: carro, nibus, moto, caminho, avio, barco, elevador (sim, o elevador tambm  um meio de transporte). Crie uma classe abstrata MeioDeTransporte com atributos que voc julga necessrios. Vamos citar alguns: tipo (se  um carro, uma moto, etc.), peso, velocidade, maximo de passageiros.
2.	Estenda a classe abstrata MeioDeTransporte para um meio de transporte terrestre. Este ser chamado MeioDeTransporteTerrestre. Ela ter atributos de meios de transporte terrestres, por exemplo: marcha, rodas, etc. Acrescente outros que julgar necessrios
3.	 Crie uma classe final chamada Carro, com mtodos de um carro: ligarCarro, desligarCarro, mudarMarcha, ligarLimpadorDeParabrisa, desligarLimpadorDeParabrisa e o que mais achar necessrio num carro. Em cada um deles coloque uma funo que de echo em algum texto ou altere parmetros dentro do objeto, ex.: $this->marcha++;
4.	Crie um objeto carro na varivel $carro, altere valor dos atributos e execute os mtodos ligarCarro, desligarCarro e outros. Ao final, execute a funo print_r($carro)
*/

abstract class MeioDeTransporte
{
    var $tipo;
    var $velocidade;
    var $passageiros;
    var $dimensao;
    var $peso;
}
class MeioDeTransporteTerrestre extends MeioDeTransporte
{
    var $marcha = 0;
    var $ligado = false;
    var $rodas;
    var $combustivel;
    var $tanque;
}
final class Carro extends MeioDeTransporteTerrestre
{
    var $seta;
    var $limpador;
    function ligarCarro()
    {
        if($this->ligado == false)
        {
            echo 'Carro ligado<br>';
            $this->ligado = true;
        }
        else
        {
            echo 'O carro j est ligado<br>';
        }
    }
    function desligarCarro()
    {
        if($this->ligado == true)
        {
            echo 'Carro desligado<br>';
            $this->ligado = false;
        }
        else
        {
            echo 'O carro j est desligado<br>';
        }
    }
    function trocarMarcha($n)
    {
        $this->marcha += $n;
        if($this->marcha < 0) $this->marcha = 0;
    }
    function acelerar()
    {
        $this->velocidade = $this->velocidade + $this->marcha;
    }
    function desacelerar()
    {
        $this->velocidade = $this->velocidade - $this->marcha;
    }
}

$carro = new Carro();
$carro->ligarCarro();
$carro->ligarCarro();
$carro->trocarMarcha(1);
$carro->desligarCarro();

print_r($carro);
?>