package PCC;


import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JTextField;


import javax.swing.JButton;

public class TelaCadastarFormadePagamento extends JFrame {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel lbtitulo = null;
	private JLabel lbcodvenda = null;
	private JLabel lbdescricao = null;
	private JTextField tdescricao = null;
	private JLabel lbdatadavenda = null;
	private JTextField tdatavenda = null;
	private JLabel lbvencvenda = null;
	private JTextField tvencvenda = null;
	private JLabel lbformapag = null;
	private JButton jButton = null;
	private JComboBox combocodvenda = null;
	private JComboBox comboformapag = null;
	/**
	 * This method initializes tdescricao	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTdescricao() {
		if (tdescricao == null) {
			tdescricao = new JTextField();
			tdescricao.setBounds(new java.awt.Rectangle(220,119,262,20));
		}
		return tdescricao;
	}

	/**
	 * This method initializes tdatavenda	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTdatavenda() {
		if (tdatavenda == null) {
			tdatavenda = new JTextField();
			tdatavenda.setBounds(new java.awt.Rectangle(220,165,100,20));
		}
		return tdatavenda;
	}

	/**
	 * This method initializes tvencvenda	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTvencvenda() {
		if (tvencvenda == null) {
			tvencvenda = new JTextField();
			tvencvenda.setBounds(new java.awt.Rectangle(220,207,101,20));
		}
		return tvencvenda;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setBounds(new java.awt.Rectangle(241,278,123,28));
			jButton.setText("Cadastar");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					
	
					String codvenda = (String) combocodvenda.getSelectedItem();
					
					String descricao = tdescricao.getText();
					String datavenda = tdatavenda.getText();
					String vencvenda = tvencvenda.getText();
					String formapag = (String)comboformapag.getSelectedItem();
					
					CadastarFormaPagamento a = new CadastarFormaPagamento();
					a.setCodvenda(codvenda);
					a.setDescricao(descricao);
					a.setDatavenda(datavenda);
					a.setVencvenda(vencvenda);
					a.setFormapag(formapag);
					a.cadastar();
					JOptionPane.showMessageDialog (null,"Cadastro feita com sucesso!","Sair",JOptionPane.INFORMATION_MESSAGE);
					TelaCadastarFormadePagamento.this.dispose();
				
				}
			});
		}
		return jButton;
	}

	/**
	 * This method initializes combocodvenda	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getCombocodvenda() {
		if (combocodvenda == null) {
			combocodvenda = new JComboBox();
			Banco banco = new Banco();
			try{
				Connection ExConn = banco.abrirBDConn();
				Statement stmt = ExConn.createStatement();
				ResultSet rs = stmt.executeQuery("SELECT codvenda FROM tabvendajava ORDER BY codvenda");
				while (rs.next()){
					combocodvenda.addItem(rs.getString("codvenda"));
				}
				combocodvenda.setBounds(new java.awt.Rectangle(220,69,182,20));
				stmt.close();
			}catch(Exception ex){
				ex.printStackTrace();
			}
		}
		return combocodvenda;
	}

	/**
	 * This method initializes comboformapag	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getComboformapag() {
		if (comboformapag == null) {
			comboformapag = new JComboBox();
			Banco banco = new Banco();
			try{
				Connection ExConn = banco.abrirBDConn();
				Statement stmt = ExConn.createStatement();
				ResultSet rs = stmt.executeQuery("SELECT formapag FROM tabformapagjava ORDER BY formapag");
				while (rs.next()){
					comboformapag.addItem(rs.getString("formapag"));
				}
				comboformapag.setBounds(new java.awt.Rectangle(220,240,182,20));
				stmt.close();
			}catch(Exception ex){
				ex.printStackTrace();
			}}
		return comboformapag;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

	/**
	 * This is the default constructor
	 */
	public TelaCadastarFormadePagamento() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(613, 370);
		this.setContentPane(getJContentPane());
		this.setTitle("Cadastar Fornecedor");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			lbformapag = new JLabel();
			lbformapag.setBounds(new java.awt.Rectangle(52,241,138,16));
			lbformapag.setText("Forma de Pagamento:");
			lbvencvenda = new JLabel();
			lbvencvenda.setBounds(new java.awt.Rectangle(52,204,138,16));
			lbvencvenda.setText("Vencimento da Venda:");
			lbdatadavenda = new JLabel();
			lbdatadavenda.setBounds(new java.awt.Rectangle(52,163,99,16));
			lbdatadavenda.setText("Data De Venda:");
			lbdescricao = new JLabel();
			lbdescricao.setBounds(new java.awt.Rectangle(52,121,71,16));
			lbdescricao.setText("Descrio:");
			lbcodvenda = new JLabel();
			lbcodvenda.setBounds(new java.awt.Rectangle(52,69,106,16));
			lbcodvenda.setText("Codigo da Venda:");
			lbtitulo = new JLabel();
			lbtitulo.setBounds(new java.awt.Rectangle(127,15,362,26));
			lbtitulo.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 24));
			lbtitulo.setText("Cadastar Forma de Pagamento");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(lbtitulo, null);
			jContentPane.add(lbcodvenda, null);
			jContentPane.add(lbdescricao, null);
			jContentPane.add(getTdescricao(), null);
			jContentPane.add(lbdatadavenda, null);
			jContentPane.add(getTdatavenda(), null);
			jContentPane.add(lbvencvenda, null);
			jContentPane.add(getTvencvenda(), null);
			jContentPane.add(lbformapag, null);
			jContentPane.add(getJButton(), null);
			jContentPane.add(getCombocodvenda(), null);
			jContentPane.add(getComboformapag(), null);
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
