package PCC;

import java.awt.BorderLayout;

import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JPasswordField;
import javax.swing.JButton;


public class TelaInicial extends JFrame {

	private JPanel jContentPane = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JTextField tlogin = null;
	private JPasswordField tsenha = null;
	private JButton jButton = null;

	/**
	 * This method initializes tlogin	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTlogin() {
		if (tlogin == null) {
			tlogin = new JTextField();
			tlogin.setBounds(new java.awt.Rectangle(134,109,274,20));
		}
		return tlogin;
	}

	/**
	 * This method initializes tsenha	
	 * 	
	 * @return javax.swing.JPasswordField	
	 */
	private JPasswordField getTsenha() {
		if (tsenha == null) {
			tsenha = new JPasswordField();
			tsenha.setBounds(new java.awt.Rectangle(134,166,273,20));
		}
		return tsenha;
	}

	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setBounds(new java.awt.Rectangle(182,246,161,30));
			jButton.setText("Entrar");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// recolhendo os dados do formulrio
					String fLogin = tlogin.getText();
					String fSenha = new String(tsenha.getPassword());
					// cria o objeto de cadastro e verifica a senha
					CadastarLog cl = new CadastarLog();
					cl.setLogin(fLogin);
					cl.setSenha(fSenha);
					String sNivel = cl.procura();
					// verifica o nvel de senha
					if (sNivel.equals("a")) {// administrador
					   MenuEntrada a = new MenuEntrada();
					   a.setVisible(true);
					}
					if (sNivel.equals("c")) {// comum
						TelaErro a = new TelaErro();
						a.setVisible(true);
					}
					if (sNivel.equals("d")) {// desconhecido
						// alerta de erro: desconhecido
						JOptionPane.showMessageDialog(null,
								"Login ou senha incorretos!", "Erro",
								JOptionPane.WARNING_MESSAGE);
					}
					if (sNivel.equals("e")) {// erro interno
						JOptionPane.showMessageDialog(null,
								"Erro na execuo!", "Erro",
								JOptionPane.ERROR_MESSAGE);
					}
				}
			});
		}
		return jButton;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}

	/**
	 * This is the default constructor
	 */
	public TelaInicial() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(597, 421);
		this.setContentPane(getJContentPane());
		this.setTitle("Login do Sistema");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel1 = new JLabel();
			jLabel1.setBounds(new java.awt.Rectangle(73,165,44,16));
			jLabel1.setText("Senha:");
			jLabel = new JLabel();
			jLabel.setBounds(new java.awt.Rectangle(73,109,38,16));
			jLabel.setText("Login:");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jLabel, null);
			jContentPane.add(jLabel1, null);
			jContentPane.add(getTlogin(), null);
			jContentPane.add(getTsenha(), null);
			jContentPane.add(getJButton(), null);
		}
		return jContentPane;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
