<?php
class Carga
{
    public $nome;
    public $peso;
    public $volume;
    public $valor;
    
    function __construct($_n, $_p, $_vol, $_val)
    {
        $this->nome   = $_n;
        $this->peso   = $_p;
        $this->volume = $_vol;
        $this->valor  = $_val;
    }
}
class Carregamento
{
    public $carga;
    
    function adicionaCarga(Carga $_c)
    {
        $this->carga[] = $_c;
    }
    function listaCargas()
    {
        foreach($this->carga as $c)
        {
            echo "{$c->nome}<br>\n";
        }
        echo '<hr>';
    }
    function calculaValorTotal()
    {
        $t = 0;
        foreach($this->carga as $c)
        {
            $t += $c->valor;
        }
        echo "O valor total do carregamento  de R\$ {$t}.<br>\n";
    }
    function calculaVolumeTotal()
    {
        $t = 0;
        foreach($this->carga as $c)
        {
            $t += $c->volume;
        }
        echo "O volume total do carregamento  de {$t}m.<br>\n";
    }
    function calculaPesoTotal()
    {
        $t = 0;
        foreach($this->carga as $c)
        {
            $t += $c->peso;
        }
        echo "O peso total do carregamento  de {$t}kg.<br>\n";
    }
}

$carga1 = new Carga('Geladeira',  '80', '.8',  '1250.60');
$carga2 = new Carga('Fogo',      '60', '.3',  '850.56');
$carga3 = new Carga('Micro-ondas',  '4', '.2',  '630.44');
$carga4 = new Carga('Computador', '12', '.35', '3554.80');
$carga5 = new Carga('Mesa',       '10', '.2',  '330.35');

$carregamento = new Carregamento();
$carregamento->adicionaCarga($carga1);
$carregamento->adicionaCarga($carga2);
$carregamento->adicionaCarga($carga3);
$carregamento->adicionaCarga($carga4);
$carregamento->adicionaCarga($carga5);

$carregamento->listaCargas();
$carregamento->calculaValorTotal();
$carregamento->calculaVolumeTotal();
$carregamento->calculaPesoTotal();
?>
